#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplague>

#define ACCESS ADMIN_LEVEL_B

new const PlayerModels[][] = 
{
    "default_admin",
    "green_admin",
    "yellow_admin",
    "blue_admin",
    "purple_admin",
    "lightblue_admin",    
    "aqwa_admin",    
    "orange_admin",
    "pink_admin"    
}

new g_playermodels[33][charsmax(PlayerModels)]

public plugin_init() 
{
    register_clcmd("say /skin", "amodels", ACCESS);
    RegisterHam(Ham_Spawn,"player","SpawnPlayer", 1)
}

public SpawnPlayer(id)
{
    if(zp_get_user_zombie(id))
        return HAM_IGNORED;
    
    if(zp_get_user_survivor(id))
        return HAM_IGNORED;
    
    if(!(get_user_flags(id) & ACCESS))
        return HAM_IGNORED;

    set_task(1.0, "SetModel", id)
    return PLUGIN_CONTINUE;
}

public SetModel(id)
{
    for(new iRange=0;iRange<=charsmax(PlayerModels);iRange++)
    {
        if(g_playermodels[id][iRange] == -1)
            continue
        
        zp_override_user_model(id, PlayerModels[g_playermodels[id][iRange]]);
        break;
    }
    remove_task(id)
}

public zp_user_humanized_post(id, survivor)
{
    if(survivor)
        return;
    
    if(!(get_user_flags(id) & ACCESS))
        return;

    for(new iRange=0;iRange<=charsmax(PlayerModels);iRange++)
    {
        if(g_playermodels[id][iRange] != -1)
        {
            zp_override_user_model(id, PlayerModels[g_playermodels[id][iRange]]);
            break;
        }
    }
}

public client_connect(id)
{
    for(new iRange=0;iRange<=charsmax(PlayerModels);iRange++)
    {
        g_playermodels[id][iRange] = -1
    }
}

public client_disconnected(id)
{
    for(new iRange=0;iRange<=charsmax(PlayerModels);iRange++)
    {
        g_playermodels[id][iRange] = -1
    }
    
    if(task_exists(id))
        remove_task(id)
}

public plugin_precache() 
{
    for(new iModels=0;iModels<=charsmax(PlayerModels);iModels++)
    {
        new szModels[64]; 
        formatex(szModels, charsmax(szModels), "models/player/adminmodels/%s/%s.mdl", PlayerModels[iModels], PlayerModels[iModels]);
        engfunc(EngFunc_PrecacheModel, szModels);
    }
}
 
public amodels(id) 
{                                
    new i_Menu = menu_create("\rВыбери \yмодель", "amodels_handler");
    menu_additem(i_Menu, "\wСтандартный", "1", 0);
    menu_additem(i_Menu, "\wЗеленый", "2", 0);
    menu_additem(i_Menu, "\wЖелтый", "3", 0);
    menu_additem(i_Menu, "\wСиний", "4", 0);
    menu_additem(i_Menu, "\wФиолетовый", "5", 0);
    menu_additem(i_Menu, "\wГолубой", "6", 0);
    menu_additem(i_Menu, "\wБирюзовый", "7", 0);
    menu_additem(i_Menu, "\wОранжевый", "8", 0)
    menu_additem(i_Menu, "\wРозовый", "9", 0)
    menu_setprop(i_Menu, MPROP_NEXTNAME, "\rДалее");
    menu_setprop(i_Menu, MPROP_BACKNAME, "\rНазад");
    menu_setprop(i_Menu, MPROP_EXITNAME, "\rВыход");   

    menu_display(id, i_Menu, 0)
}

public amodels_handler(id, menu, item) 
{
    if( item < 0 ) 
    {
        return PLUGIN_CONTINUE;
    }
    
    new cmd[3], access, callback;
    menu_item_getinfo(menu, item, access, cmd,2,_,_, callback);
    
    new Choise = str_to_num(cmd)    
    
    for(new iKeys=1;iKeys<=sizeof(PlayerModels);iKeys++)
    {
        if (Choise == iKeys)
        {
            zp_override_user_model(id, PlayerModels[iKeys-1]);
            g_playermodels[id][iKeys-1] = iKeys - 1;
        }
        else
        {
            g_playermodels[id][iKeys-1] = -1;
        }
    }          
    return PLUGIN_HANDLED;
}
